﻿Imports System.Drawing
Public Class Form1
    'initial graphic varible
    Dim g As Graphics
    Dim mesh As Pen
    Dim line As Pen
    Dim img As Bitmap
    Dim step_motion As Integer

    Dim speed_value As Integer 'get current speed
    Dim cur_x As Integer
    Dim cur_y As Integer
    Dim next_x As Integer
    Dim next_y As Integer
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' mention message
        MessageBox.Show("Please start your ISaGRAF application before press start button.", "Button Clicked", MessageBoxButtons.OK, MessageBoxIcon.None, MessageBoxDefaultButton.Button1)
        'setting timer tick
        Timer1.Interval = 250
        Timer1.Enabled = True
        step_motion = 0
        'initial position
        cur_x = 0
        cur_y = 240

        'create a bitmap canvas
        img = New Bitmap(pictureBox1.Size.Width, pictureBox1.Size.Height)
        g = Graphics.FromImage(img)
        pictureBox1.Image = img
        g.Clear(Color.White)
        draw_mesh()
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        ScanProperties() 'scan all integer properties.
        Scan_XDI() 'can x axis D/I status in ISaGRAF
        Scan_YDI() 'scan y axis D/I status in ISaGRAF
    End Sub
    Private Sub ScanProperties() 'scan all integer properties.

        Dim Value As Integer
        Dim position As String
        Value = 0
        Dim tmp As Byte
        'Get current x and y axis logic pulse. 
        Quicker.UserShare.UserGetReg_Long(Convert.ToUInt16(12), next_x)
        position = "( " + next_x.ToString() + " , "
        next_x = next_x / 5000
        Quicker.UserShare.UserGetReg_Long(Convert.ToUInt16(14), next_y)
        position += next_y.ToString() + " )"
        next_y = 240 - (next_y / 5000) 'orignal point transition
        cur_pos.Text = position

        If (cur_x - next_x) * (cur_x - next_x) > 0 Or (cur_y - next_y) * (cur_y - next_y) > 0 Then

            line_draw()
            cur_x = next_x
            cur_y = next_y
        End If
        'swap position


        'read speed
        Quicker.UserShare.UserGetReg_Long(Convert.ToUInt16(16), speed_value)
        speed.Text = speed_value.ToString()



        'show status bar
        Quicker.UserShare.UserGetReg_Long(Convert.ToUInt16(18), step_motion)
        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(28), tmp)
        'check emergency status
        If tmp = 0 Then

            emg.BackColor = Color.Black
            showstep(step_motion)

        Else
            emg.BackColor = Color.Red
            step_motion = -1
            showstep(step_motion)
        End If

        'get next position to move
        Quicker.UserShare.UserGetReg_Long(Convert.ToUInt16(20), Value)
        position = "( " + Value.ToString() + " , "

        Quicker.UserShare.UserGetReg_Long(Convert.ToUInt16(22), Value)
        position += Value.ToString() + " )"
        nxt_pos.Text = position
        'get total of point
        Quicker.UserShare.UserGetReg_Long(Convert.ToUInt16(26), Value)
        Total_p.Text = (Value / 4).ToString()
    End Sub
    Private Sub draw_mesh()

        'draw mesh by canvas size
        mesh = New Pen(Color.Silver)

        For i = 1 To 9
            g.DrawLine(mesh, i * 40, 0, i * 40, 240)
        Next


        For i = 1 To 7
            g.DrawLine(mesh, 0, i * 40, 320, i * 40)
        Next

        mesh.Dispose()

    End Sub

    Private Sub line_draw() 'drawing one line

        line = New Pen(Color.Blue)

        g.DrawLine(line, cur_x, cur_y, next_x, next_y)
        pictureBox1.Refresh()
    End Sub


    Private Sub Scan_XDI()

        Dim status As Byte
        'load limit+
        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(2), status)
        If status = 1 Then
            Limit_XP.BackColor = Color.Red
            step_motion = -1
            showstep(step_motion)
        Else
            Limit_XP.BackColor = Color.Black
        End If

        'load limit-
        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(3), status)

        If status = 1 Then
            Limit_XN.BackColor = Color.Red
            step_motion = -1
            showstep(step_motion)
        Else
            Limit_XN.BackColor = Color.Black
        End If

        'load home
        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(6), status)
        If status = 1 Then
            Home_X.BackColor = Color.Red
        Else
            Home_X.BackColor = Color.Black
        End If
        'load near home
        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(7), status)
        If status = 1 Then
            NHome_X.BackColor = Color.Red
        Else
            NHome_X.BackColor = Color.Black
        End If


    End Sub

    Private Sub Scan_YDI()

        Dim status As Byte
        'load limit+
        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(4), status)
        If status = 1 Then
            Limit_YP.BackColor = Color.Red
            step_motion = -1
            showstep(step_motion)
        Else
            Limit_YP.BackColor = Color.Black
        End If

        'load limit-
        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(5), status)
        If status = 1 Then
            Limit_YN.BackColor = Color.Red
            step_motion = -1
            showstep(step_motion)
        Else
            Limit_YN.BackColor = Color.Black
        End If

        'load home
        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(8), status)
        If status = 1 Then
            Home_Y.BackColor = Color.Red
        Else
            Home_Y.BackColor = Color.Black
        End If

        'load near home
        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(9), status)
        If status = 1 Then
            NHome_Y.BackColor = Color.Red
        Else
            NHome_Y.BackColor = Color.Black
        End If
    End Sub

    Private Sub button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button1.Click
        'click to start
        Dim tmp As Integer
        'if no file be selected.
        If comboBox1.Text = "" Then

            MessageBox.Show("Please select File ", "Button Clicked", MessageBoxButtons.OK, MessageBoxIcon.None, MessageBoxDefaultButton.Button1)
            Return

            'select item and set value to ISaGRAF 
        ElseIf comboBox1.Text = "File 1" Then

            tmp = 1
            Quicker.UserShare.UserSetReg_Long(Convert.ToUInt16(10), tmp)

            Quicker.UserShare.UserSetCoil(Convert.ToUInt16(1), 1)


        Else

            tmp = 2
            Quicker.UserShare.UserSetReg_Long(Convert.ToUInt16(10), tmp)
            Quicker.UserShare.UserSetCoil(Convert.ToUInt16(1), 1)
        End If
        pictureBox1.Refresh()
    End Sub

    Private Sub showstep(ByVal motion_step As Integer)

        Dim Value As Integer
        'show status in every status
        Select Case motion_step

            Case 0
                status_bar.Text = "please press start button to start motion"
                g.Clear(Color.White)
                draw_mesh()

            Case 1
                status_bar.Text = "Detecting X-axis Near-Home-Switch and Home-Switch."

            Case 2
                status_bar.Text = "Detecting X-axis Near-Home-Switch and Home-Switch."

            Case 3
                Quicker.UserShare.UserGetReg_Long(Convert.ToUInt16(24), Value)
                Value = (Value - 1) / 4 + 1
                status_bar.Text = "start motion " + comboBox1.Text + " NO. " + Value.ToString() + " point."

            Case 4
                status_bar.Text = "now working"

            Case 5
                status_bar.Text = "auto back to home"

            Case 20
                status_bar.Text = "wait 10 seconds"

            Case Else
                status_bar.Text = "error !!! Please check your ISaGRAF I/O connection or Manual."
                g.Clear(Color.White)
                draw_mesh()
        End Select
    End Sub

End Class
