﻿Public Class Form1
    Dim step_motion As Integer 'show status text


    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        ScanProperties() 'scan properties.
        ScanStatus() 'for all X axis boolean status varible.
        switch_step()
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        MessageBox.Show("Please start your ISaGRAF application before press start button.", "Button Clicked", MessageBoxButtons.OK, MessageBoxIcon.None, MessageBoxDefaultButton.Button1)
        step_motion = 0
        Timer1.Interval = 250
        Timer1.Enabled = True
    End Sub

    'status scan
    Private Sub ScanStatus()


        'Scan X axis D/I satus
        Dim do_value As Byte
        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(1), do_value)

        If do_value = 1 Then
            start.BackColor = Color.Red
        Else
            start.BackColor = Color.Black
        End If

        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(2), do_value)
        If do_value = 1 Then
            limit_p.BackColor = Color.Red
        Else
            limit_p.BackColor = Color.Black
        End If
        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(3), do_value)
        If do_value = 1 Then
            limit_n.BackColor = Color.Red
        Else
            limit_n.BackColor = Color.Black
        End If

        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(4), do_value)
        If do_value = 1 Then
            home.BackColor = Color.Red
        Else
            home.BackColor = Color.Black
        End If

        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(5), do_value)
        If do_value = 1 Then
            N_home.BackColor = Color.Red
        Else
            N_home.BackColor = Color.Black
        End If

        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(6), do_value)

        If do_value = 1 Then
            Drill.BackColor = Color.Red
        Else
            Drill.BackColor = Color.Black
        End If

        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(20), do_value)

        If do_value = 1 Then

            emg.BackColor = Color.Red
            step_motion = -1

        Else

            emg.BackColor = Color.Black
        End If

    End Sub
    Private Sub ScanProperties()

        Dim Value As Integer
        Value = 0
        'scan properties

        'get next position to move
        Quicker.UserShare.UserGetReg_Long(Convert.ToUInt16(7), Value)
        logic_p.Text = Value.ToString()

        'get start speed
        Quicker.UserShare.UserGetReg_Long(Convert.ToUInt16(9), Value)
        st_sp.Text = Value.ToString()

        'get drive speed
        Quicker.UserShare.UserGetReg_Long(Convert.ToUInt16(11), Value)
        drive_sp.Text = Value.ToString()
        'get search Home switch speed
        Quicker.UserShare.UserGetReg_Long(Convert.ToUInt16(13), Value)
        search_sp.Text = Value.ToString()
        'get how much pulse to move
        Quicker.UserShare.UserGetReg_Long(Convert.ToUInt16(15), Value)
        pulse_mv.Text = Value.ToString()

        'switch step show on StepStatus 
        Quicker.UserShare.UserGetReg_Short(Convert.ToUInt16(17), step_motion)

    End Sub
    Private Sub switch_step()

        Dim wait As Integer
        wait = 0

            Select step_motion

            Case 0
                StepStatus.Text = "Idleing."

            Case 1
                StepStatus.Text = "Detecing Near-Home-Switch and Home-Switch."

            Case 2
                Quicker.UserShare.UserGetReg_Short(Convert.ToUInt16(18), wait)
                wait = wait / 1000
                StepStatus.Text = "Reset pulse. wait " + wait.ToString() + " seconds"

            Case 3
                StepStatus.Text = "now move to position 1."
                position.Text = "100000"

            Case 4
                Quicker.UserShare.UserGetReg_Short(Convert.ToUInt16(18), wait)
                wait = wait / 1000
                StepStatus.Text = "Drill work " + wait.ToString() + " seconds"

            Case 5
                StepStatus.Text = "now move to position 2."
                position.Text = "250000"

            Case 6
                Quicker.UserShare.UserGetReg_Short(Convert.ToUInt16(18), wait)
                wait = wait / 1000
                StepStatus.Text = "Drill work " + wait.ToString() + " seconds"

            Case 7
                StepStatus.Text = "now move to position 3."
                position.Text = "120000"

            Case 8
                Quicker.UserShare.UserGetReg_Short(Convert.ToUInt16(18), wait)
                wait = wait / 1000
                StepStatus.Text = "Drill for " + wait.ToString() + " seconds"

            Case 9
                StepStatus.Text = "now back home!!"

            Case 21
                StepStatus.Text = "MPG mode on"

            Case Else
                StepStatus.Text = "error!!! Please check your ISaGRAF I/O connection or Manual."
        End Select
    End Sub

    Private Sub button2_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button2.Click

        Dim emgvalue As Byte
        Quicker.UserShare.UserSetCoil(Convert.ToUInt16(21), 1)
        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(20), emgvalue)

        If emgvalue <> 1 Then
            button2.Visible = False
            button3.Visible = True
        End If
    End Sub

    Private Sub button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button3.Click
        Dim emgvalue As Byte
        Quicker.UserShare.UserSetCoil(Convert.ToUInt16(22), 1)
        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(20), emgvalue)

        If emgvalue <> 1 Then
            button2.Visible = True
            button3.Visible = False
        End If

    End Sub

    Private Sub button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button1.Click
        'click then start motion
        Quicker.UserShare.UserSetCoil(Convert.ToUInt16(1), 1)
    End Sub

End Class
