﻿Public Class Form1

    'switch step for status show
    Dim step_switch As Integer

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        MessageBox.Show("Please start your ISaGRAF application before press start button.", "Button Clicked", MessageBoxButtons.OK, MessageBoxIcon.None, MessageBoxDefaultButton.Button1)
        Timer1.Interval = 250  ' 250 ms
        Timer1.Enabled = True
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Scan_DI()
        Scan_Properties()
        switch_step()
    End Sub

    Private Sub Scan_DI()
        Dim di_value As Byte

        'check start 
        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(1), di_value)

        If di_value = 1 Then
            start.BackColor = Color.Red
        Else
            start.BackColor = Color.Black
        End If
        'get x axis DI status
        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(2), di_value)

        If di_value = 1 Then
            limit_p.BackColor = Color.Red
        Else
            limit_p.BackColor = Color.Black
        End If

        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(3), di_value)

        If di_value = 1 Then
            limit_n.BackColor = Color.Red
        Else
            limit_n.BackColor = Color.Black
        End If

        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(4), di_value)

        If di_value = 1 Then
            home.BackColor = Color.Red
        Else
            home.BackColor = Color.Black
        End If

        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(5), di_value)
        If di_value = 1 Then
            nhome.BackColor = Color.Red
        Else
            nhome.BackColor = Color.Black
        End If

        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(6), di_value)
        If di_value = 1 Then
            drill.BackColor = Color.Red
        Else
            drill.BackColor = Color.Black
        End If

        Quicker.UserShare.UserGetCoil(Convert.ToUInt16(20), di_value)
        If di_value = 1 Then
            emg.BackColor = Color.Red
            step_switch = -1
        Else
            emg.BackColor = Color.Black
        End If

    End Sub
    Private Sub Scan_Properties()
        Dim Value As Integer

        'get properties value

        'get current logic pulse
        Quicker.UserShare.UserGetReg_Long(Convert.ToUInt16(7), Value)
        logic_pulse.Text = Value.ToString()

        'get start speed
        Quicker.UserShare.UserGetReg_Long(Convert.ToUInt16(9), Value)
        start_speed.Text = Value.ToString()

        'get drive speed
        Quicker.UserShare.UserGetReg_Long(Convert.ToUInt16(11), Value)
        drive_speed.Text = Value.ToString()

        'get search speed 
        Quicker.UserShare.UserGetReg_Long(Convert.ToUInt16(13), Value)
        search_speed.Text = Value.ToString()

        'get pulse to move 
        Quicker.UserShare.UserGetReg_Long(Convert.ToUInt16(15), Value)
        pul_mv.Text = Value.ToString()

        'swtich step status and check emg signal
        Quicker.UserShare.UserGetReg_Long(Convert.ToUInt16(17), step_switch)


    End Sub

    Private Sub switch_step()
        Dim wait As Integer

        Select Case step_switch
            Case 0
                status_bar.Text = "Idleing."

            Case 1
                status_bar.Text = "Detecing Near-Home-Switch and Home-Switch."

            Case 2
                Quicker.UserShare.UserGetReg_Short(Convert.ToUInt16(19), wait)
                wait = wait / 1000
                status_bar.Text = "Reset pulse. wait " + wait.ToString() + " seconds"

            Case 3
                status_bar.Text = "now move to position 1."
                nxt_pos.Text = "100000"

            Case 4
                Quicker.UserShare.UserGetReg_Short(Convert.ToUInt16(19), wait)
                wait = wait / 1000
                status_bar.Text = "Drill work " + wait.ToString() + " seconds"

            Case 5
                status_bar.Text = "now move to position 2."
                nxt_pos.Text = "250000"

            Case 6
                Quicker.UserShare.UserGetReg_Short(Convert.ToUInt16(19), wait)
                wait = wait / 1000
                status_bar.Text = "Drill work " + wait.ToString() + " seconds"

            Case 7
                status_bar.Text = "now move to position 3."
                nxt_pos.Text = "120000"

            Case 8
                Quicker.UserShare.UserGetReg_Short(Convert.ToUInt16(19), wait)
                wait = wait / 1000
                status_bar.Text = "Drill for " + wait.ToString() + " seconds"

            Case 9
                status_bar.Text = "now back home!!"

            Case Else
                status_bar.Text = "error!!! Please check your ISaGRAF I/O connection or Manual."
        End Select



    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Quicker.UserShare.UserSetCoil(Convert.ToUInt16(1), 1)
    End Sub
End Class
